#!/bin/sh
BLKID_RCSID='$Revision: 12169 $ $Date:: 2011-02-19 13:59:40 +0000 #$'

# geninitrd mod: blkid
USE_BLKID=${USE_BLKID:-yes}

# true if we should parse UUID= or LABEL= for root parameter

# setup geninitrd module
# @access	public
setup_mod_blkid() {
	blkid=$(find_tool $initrd_dir/blkid /sbin/initrd-blkid)

	if [ ! -x "$blkid" ]; then
		USE_BLKID=no
	fi
}

# generate initrd fragment
# @access	public
initrd_gen_blkid() {
	if ! is_yes "$USE_BLKID"; then
		return
	fi
	debug "Adding BLKID support to initrd"

	inst_exec $blkid /bin/blkid
	initrd_gen_devices
	add_linuxrc <<-'EOF'
		# if built with blkid change ROOT=LABEL=something into ROOT=/dev/somethingelse -
		# parsed by blkid
		if [ "${ROOT##LABEL=}" != "${ROOT}" -o "${ROOT##UUID=}" != "${ROOT}" ]; then
			ROOT="$(/bin/blkid -t $ROOT -o device -l)"
		fi
	EOF
}
