#!/bin/sh
SUSPEND_RCSID='$Revision: 12457 $ $Date:: 2012-01-05 17:07:24 +0000 #$'

# geninitrd mod: suspend
USE_SUSPEND=${USE_SUSPEND:-yes}

# resume device
resume_dev=""

# setup geninitrd module
# @access	public
setup_mod_suspend() {
	# XXX this needs tuxonice loaded first
	if is_yes "$USE_SUSPEND" && is_yes "$USE_TUXONICE"; then
		warn "Tuxonice and mainline suspend are exclusive!"
	fi

	resume=$(find_tool $initrd_dir/resume /usr/${_lib}/suspend/resume /usr/sbin/resume)

	if [ ! -x "$resume" ] || [ ! -f /etc/suspend.conf ]; then
		USE_SUSPEND=no
	fi
}

# find modules for for suspend
# @access	public
find_modules_suspend() {
	resume_dev="$(awk '/^resume device =/ { print $4 } ' /etc/suspend.conf)"

	local vgvolumes=$VGVOLUMES
	find_modules_for_devpath $resume_dev

	if [ "$VGVOLUMES" != "$vgvolumes" ]; then
		# save our VG to be able to differenciate between rootfs VG
		SUSPENDVG=$VGVOLUMES
		VGVOLUMES=$vgvolumes
		debug "suspend device is on LVM"
	fi
}

# generate initrd fragment
# @access	public
initrd_gen_suspend() {
	if ! is_yes "$USE_SUSPEND"; then
		return
	fi

	debug "Setting up suspend..."

	mknod $DESTDIR/dev/snapshot c 10 231
	mkdir -p $DESTDIR${resume_dev%/*}
	inst $resume_dev $resume_dev

	inst /etc/suspend.conf /etc/suspend.conf
	if [ -x /usr/${_lib}/suspend/resume ]; then
		inst_exec /usr/${_lib}/suspend/resume /bin/resume
	else
		inst_exec /usr/sbin/resume /bin/resume
	fi

	add_linuxrc <<-'EOF'
	resume=no
	for arg in $CMDLINE; do
		if [ "${arg##resume=}" != "${arg}" ]; then
			resume=${arg##resume=}
		fi
	done
	if [ "$resume" = "yes" ]; then
		resume
	fi
	EOF
}
